function varargout = Pant_Path(varargin)
% PANT_PATH M-file for Pant_Path.fig
%      PANT_PATH, by itself, creates a new PANT_PATH or raises the existing
%      singleton*.
%
%      H = PANT_PATH returns the handle to a new PANT_PATH or the handle to
%      the existing singleton*.
%
%      PANT_PATH('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PANT_PATH.M with the given input arguments.
%
%      PANT_PATH('Property','Value',...) creates a new PANT_PATH or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Pant_Path_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Pant_Path_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Pant_Path

% Last Modified by GUIDE v2.5 21-Nov-2003 16:56:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Pant_Path_OpeningFcn, ...
                   'gui_OutputFcn',  @Pant_Path_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Pant_Path is made visible.
function Pant_Path_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Pant_Path (see VARARGIN)

% Choose default command line output for Pant_Path
handles.output = hObject;

handles.Path_Profile(1,:)=[0 0];
axes(handles.Path);
title('Path Profile')
xlabel('X (inches)')
ylabel('Y (inches)')

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Pant_Path wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Pant_Path_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Enter.
function Enter_Callback(hObject, eventdata, handles)
% hObject    handle to Enter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles=guidata(hObject);
% Get axis and clear it
axes(handles.Path);
cla;
% Draw polygon and get vertices
handles.polygon=gpoly(gcbf);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function Save_Name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Save_Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function Save_Name_Callback(hObject, eventdata, handles)
% hObject    handle to Save_Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Save_Name as text
%        str2double(get(hObject,'String')) returns contents of Save_Name as a double


% --- Executes on button press in Save.
function Save_Callback(hObject, eventdata, handles)
% hObject    handle to Save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles=guidata(hObject);

% Get Data from polygon handle
xdata=get(handles.polygon,'Xdata');
ydata=get(handles.polygon,'Ydata');
handles.Path_Profile=[xdata' ydata'];

% Check to make sure within bounds
if((max(abs(xdata))>1.25)||(max(abs(ydata))>.75))
    error('Profile Outside of Bounds');
end

% Convert Data for use with servos
x_conv=2.5/1;
y_conv=1.5/1;
linear_profile=[handles.Path_Profile(:,1)/x_conv handles.Path_Profile(:,2)/y_conv];
radius=.5;
angle_profile=linear_profile/radius;
servo_range=256;
servo_conv=servo_range/pi;
servo_profile=round((angle_profile*servo_conv)+0);

% Save Data
string=get(handles.Save_Name,'String');
File=fopen(strcat(string,'.rc'),'w+');
frewind(File);
fprintf(File,'string gait_name = "Leg Profile Test"; \r\n');
fprintf(File,'float startup_time = 0.5; \r\n');
fprintf(File,'string transition = "marked"; \r\n');
fprintf(File,'float transition_time = 0.2; \r\n');
fprintf(File,'string leftturn  = "freeze" "freeze"  "freeze" "p_two"  "p_two" "p_two"; \r\n');
fprintf(File,'string neutral   = "p_one"  "p_one"  "freeze"  "p_two"  "p_two"  "freeze"; \r\n');
fprintf(File,'string rightturn = "p_two"  "p_two" "p_two"  "p_two" "p_two"  "p_two"; \r\n');
fprintf(File,'float profile_period = %1.2f; \r\n',(size(servo_profile,1)-1)*0.2);  %Add in extra node for wrap around

fprintf(File,'\r\nstructArray  p_one = \r\n');
fprintf(File,'    { \r\n');
fprintf(File,'        float smooth  = 0.05; \r\n');
fprintf(File,'        float p_gain  = 24.0; \r\n');
fprintf(File,'        float d_gain  = 0.67; \r\n');
fprintf(File,'        string angle_unit = "degrees"; \r\n');
fprintf(File,'    } \r\n');
fprintf(File,'    { \r\n');
fprintf(File,'        float times       = ');
for i=1:(size(servo_profile,1)-1)    fprintf(File,'%1.2f ',(i*0.2-0.2));    %Fixed time lengths of 0.2s (for now)
end;
fprintf(File,'; \r\n');
fprintf(File,'        float angles      = ');
for i=1:(size(servo_profile,1)-1)    fprintf(File,'%4d ',servo_profile(i,1));
end;
fprintf(File,'; \r\n');
fprintf(File,'        int directions    = ');
for i=1:(size(servo_profile,1)-1)    fprintf(File,'   0 ');    %Make all motor directions whichever is nearest (CW or CCW)
end;
fprintf(File,'; \r\n');
fprintf(File,'        bool stop_flags   = ');
for i=1:(size(servo_profile,1)-2)    fprintf(File,'   0 ');
end;
fprintf(File,'   1; \r\n');
fprintf(File,'    }; \r\n');

fprintf(File,'\r\nstructArray  p_two = \r\n');
fprintf(File,'    { \r\n');
fprintf(File,'        float smooth  = 0.05; \r\n');
fprintf(File,'        float p_gain  = 24.0; \r\n');
fprintf(File,'        float d_gain  = 0.67; \r\n');
fprintf(File,'        string angle_unit = "degrees"; \r\n');
fprintf(File,'    } \r\n');
fprintf(File,'    { \r\n');
fprintf(File,'        float times       = ');
for i=1:(size(servo_profile,1)-1)    fprintf(File,'%1.2f ',(i*0.2-0.2));    %Fixed time lengths of 0.2s (for now)
end;
fprintf(File,'; \r\n');
fprintf(File,'        float angles      = ');
for i=1:(size(servo_profile,1)-1)    fprintf(File,'%4d ',servo_profile(i,2));
end;
fprintf(File,'; \r\n');
fprintf(File,'        int directions    = ');
for i=1:(size(servo_profile,1)-1)    fprintf(File,'   0 ');    %Make all motor directions whichever is nearest (CW or CCW)
end;
fprintf(File,'; \r\n');
fprintf(File,'        bool stop_flags   = ');
for i=1:(size(servo_profile,1)-2)    fprintf(File,'   0 ');
end;
fprintf(File,'   1; \r\n');
fprintf(File,'    }; \r\n');
fclose(File);
guidata(hObject,handles);
